#pragma semicolon 1

#define DEBUG

#define PLUGIN_AUTHOR "jenz"
#define PLUGIN_VERSION "1.00"
#define generic_length 256

#include <sourcemod>
#include <sdktools>

#pragma newdecls required

int present = 0;
int targethuman = 0;

public Plugin myinfo = 
{
	name = "coordinates for the bot",
	author = PLUGIN_AUTHOR,
	description = "hello ",
	version = PLUGIN_VERSION,
	url = ""
};

public void OnClientDisconnect(int client)
{
	if (present == client)
	{
		present = 0;
		mysql_enable_disable_connected(0);
	}
	
}

public void OnPluginStart()
{
	//hooks
	HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
	HookEvent("player_team", event_playerteam, EventHookMode_PostNoCopy);
	
	//mysql
	sql_create_table();
}

public Action event_playerteam(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	if (client == present)
	{
		//PrintToChatAll("called event_playerteam");
		int team = event.GetInt("team");
		//PrintToChatAll("team: %i", team);
		if (team == 2 || team == 3)
			mysql_bot_not_spec();
	}
}
public void Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	targethuman = 0;
	int server_port = GetConVarInt(FindConVar("hostport"));
	if (server_port == 27015)
	{
		mysql_update_playercount();
	}
	if (present)
		mysql_clean_movement_input();
}

public void OnMapStart()
{
	sql_create_table();
	CreateTimer(1.0, recursive_pressing, INVALID_HANDLE, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

public bool TraceEntityFilterPlayer(int entity, int contentsMask)
{
	return (entity > GetMaxClients() || !entity);
}

public Action recursive_pressing(Handle timer, any data)
{
	//PrintToChatAll("present: %N", present);
	if (present && IsPlayerAlive(present))
	{
		float client_coord[3];
		float xyz[3];
		float lowest_distance = 1000000.0;
		float pos_client[3];
		GetClientAbsOrigin(present, pos_client);
		for (int i = 1; i <= MaxClients; i++)
			if (IsValidClient(i) && IsPlayerAlive(i) && GetClientTeam(i) == 3 && i != present)
			{
				float pos_i[3];
				GetClientAbsOrigin(i, pos_i);
				float dx = pos_client[0] - pos_i[0];
				float dy = pos_client[1] - pos_i[1];
				float dz = FloatAbs(pos_client[2] - pos_i[2]);
				float dist = SquareRoot(dx*dx + dy*dy + dz*dz);
				//PrintToChatAll("dist: %f", dist);
				if (dist < lowest_distance)
				{
					lowest_distance = dist;
					targethuman = i;
					client_coord = pos_i;
					xyz[0] = dx;
					xyz[1] = dy;
					xyz[2] = dz;
				}
			}
		if (IsValidClient(targethuman))
		{
			//PrintToChatAll("targethuman: %N", targethuman);
			float clientangles[3];
			GetClientAbsAngles(targethuman, clientangles);
			int keys = GetClientButtons(targethuman);
			char keyinput[generic_length];
			if (keys & IN_FORWARD)
			{
				StrCat(keyinput, sizeof(keyinput), "+forward; ");
			}
			if (keys & IN_BACK)
			{
				StrCat(keyinput, sizeof(keyinput), "+back; ");
			}
			if (keys & IN_MOVELEFT)
			{
				StrCat(keyinput, sizeof(keyinput), "+moveleft; ");
			}
			if (keys & IN_MOVERIGHT)
			{
				StrCat(keyinput, sizeof(keyinput), "+moveright; ");
			}
			if (keys & IN_JUMP)
			{
				StrCat(keyinput, sizeof(keyinput), "+jump; ");
			}
			if (keys & IN_DUCK)
			{
				StrCat(keyinput, sizeof(keyinput), "+duck; ");
			}
			mysql_send_input(keyinput, clientangles, xyz, client_coord, lowest_distance);
		}
	}
	return Plugin_Handled;
}

stock bool IsValidClient(int client)
{
	if (client > 0 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client))
	{
		return true;
	}
	return false;
}

public void OnClientPostAdminCheck(int client)
{
	//STEAM_0:1:34783317
	//STEAM_0:1:60189040
	//[U:1:120378081]
	//[U:1:69566635]
	char auth[50];
	GetClientAuthId(client, AuthId_Engine, auth, sizeof(auth)); 
	if (StrEqual("[U:1:120378081]", auth, false))
	{
		mysql_enable_disable_connected(1);
		present = client;
	}
	else if (StrEqual("STEAM_0:1:60189040", auth, false))
	{
		mysql_enable_disable_connected(1);
		present = client;
	}
}

public void sql_create_table()
{
	char error_connect[generic_length];
	Database database_connection;
	if (SQL_CheckConfig("css_autism_bot_info")) 
		database_connection = SQL_Connect("css_autism_bot_info", true, error_connect, sizeof(error_connect));
	if (database_connection == null)
		PrintToChatAll("{green}[UNLOZE] {white}Error! Could not connect to maria-DB!");
	//256 not enough
	char query_start[generic_length * 2];
	Format(query_start, sizeof(query_start), "CREATE TABLE IF NOT EXISTS unloze_css_autism_bot.`bot status` (`connected` BOOL DEFAULT false, `spectate` BOOL DEFAULT true, `ID` INT NOT NULL DEFAULT 1, `playercount` INT DEFAULT 0, PRIMARY KEY (`ID`))");
	mysql_exec_prepared_statement(database_connection, query_start);
	Format(query_start, sizeof(query_start), "CREATE TABLE IF NOT EXISTS unloze_css_autism_bot.`bot movement input` (`keyinput` text NOT NULL, `clientangles_0` FLOAT DEFAULT 0.0, `clientangles_1` FLOAT DEFAULT 0.0, `clientangles_2` FLOAT DEFAULT 0.0, `xyz_0` FLOAT DEFAULT 0.0, `xyz_1` FLOAT DEFAULT 0.0, `xyz_2` FLOAT DEFAULT 0.0, `client_coord_0` FLOAT DEFAULT 0.0, `client_coord_1` FLOAT DEFAULT 0.0, `client_coord_2` FLOAT DEFAULT 0.0, `lowest_distance` FLOAT DEFAULT 0.0, `entry_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP)");
	mysql_exec_prepared_statement(database_connection, query_start);
	Format(query_start, sizeof(query_start), "INSERT INTO unloze_css_autism_bot.`bot status` (connected, spectate, ID) VALUES (0, 1, 1) ON DUPLICATE KEY UPDATE connected = VALUES(connected), spectate = VALUES(spectate)");
	mysql_exec_prepared_statement(database_connection, query_start);
	delete database_connection;
}

public void mysql_clean_movement_input()
{
	char error_connect[generic_length];
	Database database_connection;
	if (SQL_CheckConfig("css_autism_bot_info")) 
		database_connection = SQL_Connect("css_autism_bot_info", true, error_connect, sizeof(error_connect));
	if (database_connection == null)
		PrintToChatAll("{green}[UNLOZE] {white}Error! Could not connect to maria-DB!");
	char query_start[generic_length];
	Format(query_start, sizeof(query_start), "delete from unloze_css_autism_bot.`bot movement input`");
	mysql_exec_prepared_statement(database_connection, query_start);
}

public void mysql_update_playercount()
{
	char error_connect[generic_length];
	Database database_connection;
	if (SQL_CheckConfig("css_autism_bot_info")) 
		database_connection = SQL_Connect("css_autism_bot_info", true, error_connect, sizeof(error_connect));
	if (database_connection == null)
		PrintToChatAll("{green}[UNLOZE] {white}Error! Could not connect to maria-DB!");
	char query_start[generic_length];
	Format(query_start, sizeof(query_start), "INSERT INTO unloze_css_autism_bot.`bot status` (playercount, ID) VALUES (%i, 1) ON DUPLICATE KEY UPDATE playercount = %i", MaxClients, MaxClients);
	mysql_exec_prepared_statement(database_connection, query_start);
	delete database_connection;
}

public void mysql_bot_not_spec()
{
	char error_connect[generic_length];
	Database database_connection;
	if (SQL_CheckConfig("css_autism_bot_info")) 
		database_connection = SQL_Connect("css_autism_bot_info", true, error_connect, sizeof(error_connect));
	if (database_connection == null)
		PrintToChatAll("{green}[UNLOZE] {white}Error! Could not connect to maria-DB!");
	char query_start[generic_length];
	Format(query_start, sizeof(query_start), "INSERT INTO unloze_css_autism_bot.`bot status` (connected, spectate, ID) VALUES (1, 0, 1) ON DUPLICATE KEY UPDATE connected = VALUES(connected), spectate = VALUES(spectate)");
	mysql_exec_prepared_statement(database_connection, query_start);
}

public void mysql_enable_disable_connected(int state)
{
	char error_connect[generic_length];
	Database database_connection;
	if (SQL_CheckConfig("css_autism_bot_info"))
		database_connection = SQL_Connect("css_autism_bot_info", true, error_connect, sizeof(error_connect));
	if (database_connection == null)
		PrintToChatAll("{green}[UNLOZE] {white}Error! Could not connect to maria-DB!");
	char query_start[generic_length];
	if (!state)
		Format(query_start, sizeof(query_start), "INSERT INTO unloze_css_autism_bot.`bot status` (connected, spectate, ID) VALUES (0, 1, 1) ON DUPLICATE KEY UPDATE connected = VALUES(connected), spectate = VALUES(spectate)");
	else
		Format(query_start, sizeof(query_start), "INSERT INTO unloze_css_autism_bot.`bot status` (connected, spectate, ID) VALUES (1, 1, 1) ON DUPLICATE KEY UPDATE connected = VALUES(connected), spectate = VALUES(spectate)");
	//PrintToChatAll("query_start: %s", query_start);
	mysql_exec_prepared_statement(database_connection, query_start);
	delete database_connection;
}

public void mysql_send_input(char []keyinput, float clientangles[3], float xyz[3], float client_coord[3], float lowest_distance)
{
	//TODO maybe add autism bot coords too as information
	char error_connect[generic_length];
	Database database_connection;
	if (SQL_CheckConfig("css_autism_bot_info")) 
		database_connection = SQL_Connect("css_autism_bot_info", true, error_connect, sizeof(error_connect));
	if (database_connection == null)
		PrintToChatAll("{green}[UNLOZE] {white}Error! Could not connect to maria-DB!");
	char query_start[generic_length];
	Format(query_start, sizeof(query_start), "INSERT INTO unloze_css_autism_bot.`bot movement input` VALUES ('%s', %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, NOW())", keyinput, clientangles[0], clientangles[1], clientangles[2], xyz[0], xyz[1], xyz[2], client_coord[0], client_coord[1], client_coord[2], lowest_distance);
	mysql_exec_prepared_statement(database_connection, query_start);
	//PrintToChatAll("query_start: %s", query_start);
	delete database_connection;
}

public void mysql_exec_prepared_statement(Database database_connection, char []query_statement)
{
	char error[generic_length];
	DBStatement create_statement = SQL_PrepareQuery(database_connection, query_statement, error, sizeof(error));
	if (create_statement == INVALID_HANDLE)
	{
		CloseHandle(create_statement);
		return;
	}
	SQL_Execute(create_statement);
	CloseHandle(create_statement);
}